﻿using System;
using System.Collections.Generic;
using TSLab.Script;
using TSLab.Script.Handlers;
using TSLab.Script.Helpers;


namespace LinearRegSlope_
{
	public class LinearRegSlope : IDouble2DoubleHandler
	{
		[HandlerParameter(true, "14", Min = "1", Max = "100", Step = "1")]
		public int Length { get; set; }

		public IList<double> Execute(IList<double> source)
		{
			var P = source;
			var LRS = new double[P.Count];
			var EMA_ = Series.EMA(P,1);
			double SumBars=Length * (Length - 1) * 0.5;
   			double SumSqrBars=(Length - 1.0) * Length * (2.0 * Length - 1.0)/6.0;
			
   			for(int i = 0; i < P.Count; i++)
			{
				if(i<Length) LRS[i]=0;
				else
				{
					double Sum1=0;
					double SumY=0;
					for(int j = 0; j <= Length-1; j++)
					{
						Sum1+=j*EMA_[i-j];
						SumY+=EMA_[i-j];
					}	
					double Sum2 = SumBars * SumY;
      				double Num1 = Length * Sum1 - Sum2;
      				double Num2 = (SumBars * SumBars) - (Length * SumSqrBars);
      				
      				if(Num2!=0) LRS[i]=100*Num1/Num2;
      				else LRS[i]=0;
				}
			}
			return LRS;
		}
	}
}